program Leveleditor;
USES Ugra,Umaus,UTasten,crt;

TYPE bloeckeType = OBJECT
                   x,y:byte;
                   farbe:byte;
                   da:shortint;
                 END;

     Maustype = object
                  x,y:integer;
                  l,r,an :boolean;
                  sprite:byte;
                  procedure update;
                  FUNCTION  Min (x1,x2,y1,y2:Integer):Boolean;
                  procedure Run;
                end;

const  rand_d   = 5; {Dicke des Randes}
       bloeckeV = 7; {wie viele verschiedene Blcke}
       bloecke_x= 15;{x Gre der Blcke}
       bloecke_y= 10;{was ist das wohl ??!!}
       bloeckeNum=255;
       dname    = 'test.dat';

VAR Maus   : MausType;
    bloecke: array [1..BloeckeNum] of bloecketype;
    maussprite,bnum,level:byte;

procedure maustype.update;
begin
 minfo(x,y,l,r);
 if y<170 then
   begin
    an:=true;
    y:=y div bloecke_y;
    x:=x div bloecke_x;
    y:=y*bloecke_y+rand_d;
    x:=x*bloecke_x+rand_d;
    sprite:=maussprite;
   end
    else begin sprite:=maussprite; an:=false; end;
end;

procedure maustype.run;
begin
 blitsprite(maus.x,maus.y,sprite);
end;

FUNCTION maustype.Min (x1,x2,y1,y2:Integer):Boolean;
BEGIN
   Min:=(x1<x) AND (x2>x) AND (y1<y) AND (y2>y);
END;

procedure rand;
begin
 blitsprite(0,0,2);
 blitsprite(0,0,1);
 blitsprite(315,0,3);
end;

procedure laden;
begin
  Load_pal('gfx2.pal');
  Set_Pal;
  Load_Sprite('maus.scx');    {  0 }
  Load_Sprite('L_rand.scx');  {  1 }
  Load_Sprite('Oben.scx');    {  2 }
  Load_Sprite('R_rand.scx');  {  3 }

  Load_Sprite('R_block.scx'); {  4 }
  Load_Sprite('g_block.scx'); {  5 }
  Load_Sprite('gr_block.scx');{  6 }
  Load_Sprite('ge_block.scx');{  7 }
  Load_Sprite('b_block.scx'); {  8 }
  Load_Sprite('l_block.scx'); {  9 }
  Load_Sprite('br_block.scx');{ 10 }
  Load_Sprite('t_block.scx'); { 11 }
end;

procedure leiste;
var i:byte;
    x,y:word;
begin
 y:=180;
 x:=0;
 for i:=4 to 11 do
  begin
   x:=x+bloecke_x+5;
   blitsprite(x,y,i);
  end;
end;

procedure auswaelen;
var i:byte;
    x1,x2,x:word;
begin
  x:=5+bloecke_x;
  for i:=1 to 8 do
  begin
   x1:=(x+bloecke_x+5-x)*i;
   x2:=(x+bloecke_x+5-x)*i+bloecke_x;
   if (maus.l) and (maus.Min(x1,x2,180,180+bloecke_y))
     then maussprite:=4+i-1;
  end
end;

procedure bauen;
var i:byte;
begin
 if maus.an then
   if maus.l then
    begin
     inc(bnum);
     bloecke[Bnum].x    :=maus.x div bloecke_x;
     bloecke[Bnum].y    :=maus.y div bloecke_y;
     bloecke[Bnum].farbe:= maussprite-4;
     bloecke[Bnum].da   := 1;
     repeat
      maus.update;
     until not maus.l;
    end;
end;

procedure clear;
var i:byte;
begin
  for i:=1 to Bnum do
   begin
     bloecke[Bnum].x:=0;
     bloecke[Bnum].y:=0;
     bloecke[Bnum].farbe:=0;
   end;
  bnum:=0;
end;

procedure oops;

begin
  bloecke[Bnum].x:=0;
  bloecke[Bnum].y:=0;
  bloecke[Bnum].farbe:=0;
  dec(bnum);
  repeat
  until not taste[24];
end;

procedure putBloecke;
var i:byte;
begin
 for i:=1 to BNum do
  blitsprite((bloecke[i].x*bloecke_x)+rand_d,(bloecke[i].y*bloecke_y)+rand_d,
             bloecke[i].farbe+4)
end;

procedure BloeckeLaden(il:byte);
var f:file;
    i,x,y,fa,da:byte;
begin
 assign(f,dname);
 reset(f,1);
 seek(f,(255*4*(il-1)+1));
 blockread(f,bNum,1);
 for i:=1 to bNum do
  begin
   blockread(f,x,1);
   blockread(f,y,1);
   blockread(f,fa,1);
   blockread(f,da,1);
   if x>31 then x:=31;
   if y>18 then x:=18;
   if fa>7 then x:=7;
   bloecke[i].x     := x*bloecke_x+rand_d;
   bloecke[i].y     := y*bloecke_y+rand_d;
   bloecke[i].farbe := fa;
   bloecke[i].da    := da-128;
  end;
 close(f);
end;

procedure levladen;
var f:file;
    l:byte;
begin
 assign(f,dname);
{ level:=1;
 rewrite(f,1);
 blockwrite(f,level,1);
 seek(f,0);{}
 reset(f,1);
 blockread(f,level,1);
 inc(level);
 close(f);{}
end;

procedure speichern;
var f:file;
    i,il,rea:byte;
    b,l:byte;
begin
 assign(f,dname);
 reset(f,1);
 l:=level;
 seek(f,0);{}
 blockwrite(f,l,1);
 seek(f,255*4*(l-1)+1);
 blockwrite(f,bNum,1);
 for i:=1 to 255 do
  begin
   blockwrite(f,bloecke[i].x,1);
   blockwrite(f,bloecke[i].y,1);
   blockwrite(f,bloecke[i].farbe,1);
   bloecke[i].da:=bloecke[i].da+128;
   blockwrite(f,bloecke[i].da,1);
  end;
 close(f);
end;

begin
 gra_on;
 tasten_on;
 laden;
 bnum:=0;
 levladen;
 mausfenstersetzen(0,0,300,198);
 repeat
 cls;
 if bNUM>0 then putbloecke;
 leiste;
 auswaelen;
 maus.update;
 maus.run;
 bauen;
 rand;
 Draw_string(20,20,1,InttoStr(level));
 Draw_string(100,20,1,InttoStr(bnum));
 Draw_string(300,180,1,InttoStr(Bloecke[bnum-1].da));
 if taste[11] then Bloecke[bnum-1].da:=-1;
 if taste[2] then Bloecke[bnum-1].da:=1;
 if taste[3] then Bloecke[bnum-1].da:=3;
 if taste[4] then Bloecke[bnum-1].da:=4;
 if taste[24] then oops;
 if taste[46] then clear;
 if taste[60] then
  begin
   speichern;
   clear;
   inc(level);
   repeat
   until not Taste[60];
  end;
 if taste[38] then
  begin
{   clear;}
   if level>=2 then dec(level);
   bloeckeladen(level);
   repeat
   until not Taste[38];
  end;
 draw_all;
 until taste[T_ESC];
 gra_off;
 tasten_off;
end.